import React from 'react';
import { ComponentMetaHolder } from '@teambit/react.ui.highlighter.component-metadata.bit-component-meta';
import { Placement, LabelSize } from '../label';
export declare type HighlighterSize = LabelSize;
export interface ElementHighlighterProps extends React.HTMLAttributes<HTMLDivElement> {
    /** target element to highlight */
    target: HighlightTarget;
    /** default location of the label */
    placement?: Placement;
    /** customize styles */
    classes?: HighlightClasses;
    /** continually update highlighter to match moving elements */
    watchMotion?: boolean;
    size?: HighlighterSize;
}
export { Placement };
export declare type HighlightTarget = {
    /** element to show the highlight at */
    element: HTMLElement;
    /** components with metadata to show in the label */
    components?: ComponentMetaHolder[];
};
export declare type HighlightClasses = {
    container?: string;
    frame?: string;
    label?: string;
};
export declare function ElementHighlighter({ target, placement, watchMotion, className, classes, size, ...props }: ElementHighlighterProps): JSX.Element;
