"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Frame = void 0;
const react_1 = __importStar(require("react"));
const react_popper_1 = require("react-popper");
const classnames_1 = __importDefault(require("classnames"));
require("@popperjs/core");
const base_ui_utils_popper_js_ignore_popper_size_1 = require("@teambit/base-ui.utils.popper-js.ignore-popper-size");
const base_ui_utils_popper_js_resize_to_match_reference_1 = require("@teambit/base-ui.utils.popper-js.resize-to-match-reference");
const use_animation_frame_1 = require("../use-animation-frame");
const frame_module_scss_1 = __importDefault(require("./frame.module.scss"));
const BASE_OFFSET = +frame_module_scss_1.default.offset;
const popperModifiers = [
    base_ui_utils_popper_js_ignore_popper_size_1.ignorePopperSize,
    base_ui_utils_popper_js_resize_to_match_reference_1.resizeToMatchReference,
    {
        name: 'flip',
        enabled: false,
    },
    {
        name: 'offset',
        options: {
            // move box from above the target ('top-start')
            // to directly cover the target.
            offset: ({ reference }) => [BASE_OFFSET, BASE_OFFSET - reference.height],
        },
    },
];
function Frame({ targetRef, watchMotion, className, stylesClass = frame_module_scss_1.default.overlayBorder, style, }) {
    const [referenceElement, setReferenceElement] = (0, react_1.useState)(null);
    const { styles, attributes, update } = (0, react_popper_1.usePopper)(targetRef, referenceElement, {
        modifiers: popperModifiers,
        placement: 'top-start',
    });
    (0, use_animation_frame_1.useAnimationFrame)(!!watchMotion && update);
    if (!targetRef)
        return null;
    return (react_1.default.createElement("div", Object.assign({ ref: setReferenceElement, className: (0, classnames_1.default)(className, stylesClass), style: Object.assign(Object.assign({}, styles.popper), style) }, attributes.popper)));
}
exports.Frame = Frame;
//# sourceMappingURL=frame.js.map