"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useAnimationFrame = void 0;
const react_1 = require("react");
// TODO - extract to its own component
function useAnimationFrame(cb, deps = []) {
    (0, react_1.useEffect)(() => {
        if (!cb)
            return () => { };
        let animationFrameId = -1;
        const animate = () => {
            cb();
            animationFrameId = window.requestAnimationFrame(animate);
        };
        animate();
        return () => {
            if (animationFrameId > -1)
                window.cancelAnimationFrame(animationFrameId);
        };
    }, [cb, ...deps]);
}
exports.useAnimationFrame = useAnimationFrame;
//# sourceMappingURL=use-animation-frame.js.map